Scriptname RDS_controller extends Quest conditional


; CONSTANTS
RDS_PlayerApproachScript Property Main Auto
RDS_MCM Property MCM auto
RDS_NPCApproachScript Property Secondary Auto
SexLabFramework Property SexLab auto
slaInternalScr Property slaScript auto
GlobalVariable Property RDS_X auto
GlobalVariable Property RDS_y auto
ReferenceAlias Property ActiveNPC auto
actor property playerRef auto
AssociationType Property Spouse  Auto
Faction Property RDS_Friendzone auto

; FOR EXTERNAL USE
Int Property Affection auto conditional hidden
string Property Personality auto  conditional hidden
string Property Trait1 auto conditional hidden
string Property sexuality auto conditional hidden
string Property relationshipStatus auto hidden
int Property turn auto conditional hidden
string Property Behavior auto conditional hidden
int property PlayerExposure auto conditional hidden     ; meaning player arousal
bool property sexualityMatch auto conditional hidden
int property NPCsexuality auto conditional hidden		; 0 = homo, 1 = hetero/bi
int property PCgender auto conditional hidden			; 0 = female, 1 = male -> confused the sexlab order and turned it around
int property NPCsex auto conditional hidden			; 0 = female, 1 = male
int property NPCpersonality auto conditional hidden  	; 1 = choleric, 2 = confidant, 3 = realistic, 4 = shy, 5 = Sophisticated
bool property localPartner = false auto conditional hidden

; INTERNAL UTILITIES
int Property pos auto hidden
int Property mood auto hidden
float Property time auto hidden
bool Property step auto hidden
bool Property sexualityCommented auto hidden
bool Property everyOther auto hidden
bool property onlyOnce auto hidden
int property X_move auto hidden
int property Y_move auto hidden
bool property NPCisFlirting auto hidden
int property lastX auto hidden
int property flirtCount auto hidden
int property iDialog auto hidden

Function SetUp_NPC()

	pos = Main.NPC_ID.Find(ActiveNPC.getRef() as Actor)
	If pos >= 0																					 ;NPC already safed and in stoarge array
		Personality = Main.NPC_Personality[pos]
		Trait1 = Main.NPC_Trait1[pos]
		Affection = Main.NPC_Affection[pos]
		sexuality = Main.NPC_sexuality[pos]
		relationshipStatus = main.NPC_relationshipStatus[pos]
		iDialog = main.NPC_dialogueCount[pos]
		iDialog += 1
		main.NPC_dialogueCount[pos] = iDialog
		
	else 																										 ;NPC has to be setup
		pos = Secondary.Setup_NPC(ActiveNPC.getRef() as Actor)
		Personality = Main.NPC_Personality[pos]
		Trait1 = Main.NPC_Trait1[pos]
		Affection = Main.NPC_Affection[pos]
		sexuality = Main.NPC_sexuality[pos]
		relationshipStatus = main.NPC_relationshipStatus[pos]
		iDialog = main.NPC_dialogueCount[pos]
		iDialog += 1
		main.NPC_dialogueCount[pos] = iDialog
		
	endif
		
	if ActiveNPC.getActorRef().isInFaction(RDS_Friendzone) && (Utility.getCurrentGameTime() - main.NPC_time[pos]) >= MCM.fzCooldown
		ActiveNPC.getActorRef().removeFromFaction(RDS_Friendzone)
	endif
		
	PlayerExposure = slaScript.getActorArousal(playerRef)
	behavior = MCM.behavior
	mood = Utility.RandomInt(-1, 1)
	step = true
	onlyOnce = true
	
	PCgender = SexLab.getGender(playerRef)
	If PCgender == 1						;I confused the genders in the dialogue conditions, so I swap them here
		PCgender = 0
	elseIf PCgender == 0
		PCgender = 1
	endif	
	
	NPCsex = SexLab.getGender(ActiveNPC.GetRef() as Actor)
	If NPCsex == 1
		NPCsex = 0
	elseIf NPCsex == 0
		NPCsex = 1
	endif
	
	If (PCgender == NPCsex && sexuality == "Homo") || (PCgender != NPCsex && sexuality == "Hetero") || sexuality == "Bi"
		sexualityMatch = true
	else
		sexualityMatch = false
	endif
	If !MCM.unmatchingSexuality
		sexualityMatch = true
	endif
	
	if sexuality == "homo"
		npcSexuality = 0
	else
		npcSexuality = 1
	endif

	If Personality == "Choleric"
		NPCpersonality = 1
	elseif Personality == "Confidant"
		NPCpersonality = 2
	elseif Personality == "Realistic"
		NPCpersonality = 3
	elseif Personality == "Shy"
		NPCpersonality = 4
	elseif Personality == "Sophisticated"
		NPCpersonality = 5
	endif
	
	X_move = 0										; X and Y _move are saved over turns, while arousal and affection infulence is deleted and doesn't add up
	Y_move = 0
	turn = 0
	
	NPCisFlirting = false
	sexualityCommented = false						;set to false at the beginning of the dialogue for proper comments
	everyOther = false
	
	RDS_X.SetValue(0)								; dialogue starts at 0
	RDS_Y.SetValue(0)
	;Calc_XY()

	string hold = main.NPC_homeHold[pos]
	localPartner = true
	if hold == "eastmarch"
		localPartner = false
	elseif hold == "falkreath"
		localPartner = false
	elseif hold == "haarfingar"
		localPartner = false
	elseif hold == "hjaalmarch"
		localPartner = false
	elseif hold == "pale"
		localPartner = false
	elseif hold == "reach" 
		localPartner = false
	elseif hold == "rift"
		localPartner = false
	elseif hold == "whiterun" 
		localPartner = false
	elseif hold == "winterhold" 
		localPartner = false
	endif

EndFunction

Function Calc_XY()									; arousal and affection influence is applyed new every turn, but response and drift adds up
	int X = 0
	int Y = 0

	; mood
	If onlyOnce
		Y_move += Mood
		onlyOnce = false
	endif

	; arsousal

	int aro = slaScript.GetActorArousal(ActiveNPC.getRef() as Actor)

	If aro <= 5
		X += 3
	elseif aro <= 10
		X += 2
	elseif aro <= 15
		X += 1
	elseif aro <= 20
		X += 0
	elseif aro <= 25
		X -= 1
	elseif aro <= 30
		X -= 1
	elseif aro <= 40
		X -= 2
	elseif aro <= 50
		X -= 3
	elseif aro <= 60
		X -= 3
	elseif aro <= 70
		X -= 4
	else
		X -= 5
	endif

	; affection

	If affection >= 0
		If Affection <= 10
			Y += 0
		elseif Affection <= 20
			Y += 1
		elseif Affection <= 30
			Y += 1
		elseif Affection <= 40
			Y += 2
		elseif Affection <= 50
			Y += 2
		elseif Affection <= 60
			Y += 3
		elseif Affection <= 70
			Y += 3
		elseif Affection <= 80
			Y += 4
		elseif Affection <= 90
			Y += 4
		elseif Affection <= 100
			Y += 5
		endif
	else
		If Affection <= -10
			Y -= 0
		elseif Affection <= -20
			Y -= 1	
		elseif Affection <= -30
			Y -= 1
		elseif Affection <= -40
			Y -= 2
		elseif Affection <= -50
			Y -= 2
		elseif Affection <= -60
			Y -= 3
		elseif Affection <= -70
			Y -= 3
		elseif Affection <= -80
			Y -= 4
		elseif Affection <= -90
			Y -= 4
		elseif Affection <= -100
			Y -= 5
		endif
	endif

	; personality-behavior interaction drift

	step = !step					; needed for alternating steps of the drift
	If Personality == "Choleric"
		If behavior == "shy"
			SW()
		elseIf behavior == "cute"
			WWS()
		elseIf behavior == "flirty"
			WWN()
		elseIf behavior == "frindly"
			SSE()
		elseIf behavior == "cold"
			South()
		else
			SE()
		endif
	elseif Personality == "Realistic"
		If behavior == "shy"
			WWS()
		elseIf behavior == "cute"
			NW()
		elseIf behavior == "flirty"
			West()
		elseIf behavior == "frindly"
			NE()
		elseIf behavior == "cold"
			SSE()
		else
			EES()
		endif
	elseif Personality == "Confidant"
		If behavior == "shy"
			EEN()
		elseIf behavior == "cute"
			WWN()
		elseIf behavior == "flirty"
			NW()
		elseIf behavior == "frindly"
			West()
		elseIf behavior == "cold"
			East()
		else
			North()
		endif
	elseif Personality == "Shy"
		If behavior == "shy"
			NE()
		elseIf behavior == "cute"
			SW()
		elseIf behavior == "flirty"
			WWS()
		elseIf behavior == "frindly"
			NNW()
		elseIf behavior == "cold"
			EES()
		else
			East()
		endif
	elseif Personality == "Sophisticated"
		If behavior == "shy"
			EES()
		elseIf behavior == "cute"
			SSW()
		elseIf behavior == "flirty"
			SSE()
		elseIf behavior == "frindly"
			North()
		elseIf behavior == "cold"
			SE()
		else
			NE()
		endif
	endif

	;add values together

	Y += Y_move
	X += X_move
	
	;traits
	
	actor activeActor = ActiveNPC.getRef() as Actor
	int exposure = slaScript.getActorExposure(activeActor)

	If Trait1 == "perverted"
		X -= 2
		exposure += 4
	elseif Trait1 == "cruel"
		Y -= 2
		affection -= 2
		If X > 2
			X = 2
			exposure += 3
		else 
			exposure += 1
		endif
	elseif Trait1 == "prude"
		X += 2
		exposure -= 4
	elseif Trait1 == "low self-esteem"
		X += 1
		Y -= 1
		exposure -= 2
		affection -= 1
	elseif Trait1 == "cold"
		If Y > 4
			Y = 4
		elseif Y < -4
			Y = -4
		endif
		If affection > 10
			affection -= 5
		elseIf affection < -10
			affection += 5
		endif
	elseif Trait1 == "cunning" ;trait gets removed after firt sexy time
		X -= 2
		Y += 2
		affection += 2
		exposure += 2
	elseif Trait1 == "romantic"
		If X >= -1 || X <= 1 
			Y += 1
			affection += 2
		endif
		If X <= -1
			exposure -= 2
		elseIf X >= 1
			exposure += 2
		endif
	elseif Trait1 == "abusive"
		If Y <= -4
			Y -= 1
		elseif Y > -1
			Y -= 2
			affection -= 5
		else 
			affection -= 2
		endif
		If X > 1
			X -= 1
			exposure += 5
		else
			exposure += 2
		endif
	else ; Trait1 == "charming"
		Y += 1
		affection += 2
	endif

	slaScript.setActorExposure(ActiveActor, exposure)

	;cap

	If X > 5
		X = 5
	endif
	If X < -5
		X = -5
	endif
	If Y > 5
		Y = 5
	endif
	If Y < -5
		Y = -5
	endif
	
	If x <= lastX && x < -1		  ;check if npc is flirting (movement in the right half, beyond -1)
		NPCisFlirting = true
	else 
		NPCisFlirting = false
	endif
	lastX = x
	
	RDS_X.SetValue(X)
	RDS_Y.SetValue(Y)
	
EndFunction


													;##########################################################
													;#	 				Player Response 			 		  #
													;##########################################################


Function PlayerAction(String PLAction)

	int X = RDS_X.getValue() as int
	int Y = RDS_Y.getValue() as int

	int arousal 										; change value depending on player action
	actor activeActor = ActiveNPC.getRef() as Actor
	int exposure = slaScript.getActorExposure(activeActor)

	; CHECK GENDER AND SEXUALITY AND ADJUST AROUSAL
	If (PCgender == NPCsex && sexuality == "Homo") || (PCgender != NPCsex && sexuality == "Hetero") || sexuality == "Bi"
		If X > 2
			exposure += 3																												
		elseIf X < -2
			exposure += 1
		elseIf X < 2
			exposure += 2
		endif
		
		armor wornArmor = playerRef.GetWornForm(0x00000004) as Armor
		If wornArmor != none								
			int Z = MCM.bodyArmorStorage.find(wornArmor)
			If Z > -1
				If MCM.bodyArmorFlagStorage[Z] == "covering"
					exposure -= 3	
				elseif  MCM.bodyArmorFlagStorage[Z] == "revealing"
					exposure += 3
				elseif  MCM.bodyArmorFlagStorage[Z] == "skimpy"
					exposure += 4
				elseif  MCM.bodyArmorFlagStorage[Z] == "naked"
					exposure += 5
				endif
			endif
		else
			exposure += 5 ; player is naked
		endif		
	else
		If X < -2																													;only reduce arousal when on the flirty side
			exposure -= 3																											; -3 if wrong gender
		elseif X < 0
			exposure -= 2
		elseif X < 2
			exposure -= 1
		endif
	endif
	If activeActor.hasAssociation(Spouse)																							; married NPC get arousal penalty
		exposure -= 5
	endif

	; update exposure (needed for dialogue conditions)
	
	PlayerExposure = slaScript.getActorArousal(playerRef)

	; PLAYER ACTION

;	X_move = 0					; clear from last turn
;	Y_move = 0

	If PLAction == "shareSecrets" ;NNW
		If X > -2
			X_move -= 1
		elseIf X < -3
			X_move += 1
		endif
		arousal += 2
		Y_move += 1
		affection += 2
	elseIf PLAction == "joke"	;N
		If X < -1
			X_move += 1
		elseIf X > 1
			X_move -= 1
		endif
		Y_move += 1 
		affection += 2
	elseif PLAction == "compliment"		;NNE
		If X < 2
			X_move += 1
		elseIf X > 3
			X_move -= 1 
		endif
		arousal -= 1
		Y_move += 1
		affection += 2
						;++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	elseif PLAction == "shareEmotions"	;NE
		If X < 0
			X_move += 2
		elseIf X < 4
			X_move += 1
		endif
		arousal -= 5
		Y_move += 1
		affection += 2
	elseif PLAction == "encourage"		;EEN
		If X < 0
			X_move += 2
		elseIf X < 4
			X_move += 1
		endif
		arousal -= 5
		Y_move += 1
		affection += 1
	elseif PLAction == "smalltalk"		;E
		If X < 0
			X_move += 2
		elseIf X < 4
			X_move += 1
		endif
		arousal -= 5
	elseif PLAction == "lecture"		;EES
		If X < 0
			X_move += 2
		elseIf X < 4
			X_move += 1
		endif
		arousal -= 5
		Y_move -= 1
		affection -= 1
	elseif PLAction == "insult"			;SE
		If X < 0
			X_move += 2
		elseIf X < 4
			X_move += 1
		endif
		arousal -= 5
		Y_move -= 1
		affection -= 2
								;+++++++++++++++++++++++++++++++++++++++++++++++
	elseif PLAction == "mock"		;SSE
		If X < 2
			X_move += 1
		elseIf X > 3
			X_move -= 1 
		endif
		arousal -= 1
		Y_move -= 1
		affection -= 2
	elseif PLAction == "provoke"	;S
		If X < -1
			X_move += 1
		elseIf X > 1
			X_move -= 1
		endif
		Y_move -= 1
		affection -= 2
	elseif PLAction == "belittle"	;SSW
		If X > -2
			X_move -= 1
		elseIf X < -3
			X_move += 1
		endif
		arousal += 2
		Y_move -= 1
		affection -= 2
								;----------------------------------------------------
	elseif PLAction == "coerce"		;SW
		If X > 0
			X_move -= 2
		elseIf X > -4
			X_move -= 1
		endif
		arousal += 2
		Y_move -= 1
		affection -= 2
	elseif PLAction == "sexist"		;WWS
		If X > 0
			X_move -= 2
		elseIf X > -4
			X_move -= 1
		endif
		arousal += 3
		Y_move -= 1
		affection -= 1
	elseif PLAction == "pickup"	;W
		If X > 0
			X_move -= 2
		elseIf X > -4
			X_move -= 1
		endif
		arousal += 3
	elseif PLAction == "flirt"		;WWN
		If X > 0
			X_move -= 2
		elseIf X > -4
			X_move -= 1
		endif
		arousal += 3
		Y_move += 1
		affection += 1
	elseif PLAction == "dirtytalk"	;NW
		If X > 0
			X_move -= 2
		elseIf X > -4
			X_move -= 1
		endif
		arousal += 2
		Y_move += 1
		affection += 2
							;------------------------------------------------------------
	elseif PLAction == "fight"
		arousal -= 20
		affection -= 20
	elseif PLAction == "demandGold"
		arousal -= 20
		affection -= 20
	elseif PLAction == "demandSex"
		arousal -= 20
		affection -= 20
	elseif PLAction == "goodbye"
		;it does nothing
	elseif PLAction == "sentAway"
		arousal -= 10
		affection -= 5
	elseif PLAction == "sexInvite"
		arousal += 10
		affection += 2
	endif

	If affection > 100
		affection = 100
	endif
	If affection > 80 && Main.NPC_relationshipStatus[pos] != "partner"
		affection = 80
	elseIf affection < -100
		affection = -100
	endif

	exposure += arousal
	slaScript.setActorExposure(ActiveActor, exposure)
							
							
							;###################################################
							;#              Comment System 					   #
							;###################################################


	string Name = ActiveNPC.getActorRef().GetleveledActorBase().GetName()

		if !sexualityCommented && MCM.sexualityComments
			if (PCgender == NPCsex && sexuality == "Homo") || (PCgender != NPCsex && sexuality == "Hetero") || sexuality == "Bi"
				Debug.Notification( Name + " seems to be attracted to you.")
			else	
				Debug.Notification( Name + " doesn't seem to be attracted to you.")
			endif
			sexualityCommented = true
		elseif everyOther && MCM.moodComments
			if Y > 2 && X < -2
				Debug.Notification( Name + " feels flirty." )
			elseif Y > 2 && X > -3 && X < 3
				Debug.Notification( Name + " feels amused." )			
			elseif Y > 2 && X > 2
				Debug.Notification( Name + " feels valued." )
			elseif Y < 3 && Y > -3 && X < -2
				Debug.Notification( Name + " feels lusty." )
			elseif Y < 3 && Y > -3 && X < 3 && X > -3
				Debug.Notification( Name + " feels indiffrent." )
			elseif Y < 3 && Y > -3 && X > 2
				Debug.Notification( Name + " feels insecure." )
			elseif X < -2 && Y < -2
				Debug.Notification( Name + " feels malicious." )
			elseif Y < -2 && X > -3 && X < 3
				Debug.Notification( Name + " is angry." )
			elseif Y < -2 && X > 2
				Debug.Notification( Name + " is offended." )
			endif
			everyOther = !everyOther
		endif
			everyOther = !everyOther
endfunction

function SetAffection()

	Main.NPC_Affection[pos] = Affection

	string Name = ActiveNPC.getActorRef().GetleveledActorBase().GetName()

	Int Rank
	If Affection <= -100
		Rank = -4
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification("You are now " + Name + "'s archenemy!")
		endif
	elseIf Affection <= -60
		Rank = -3
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " hates you!")
		endif
	elseIf Affection <= -30
		Rank = -2
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " dispises you!")
		endif
	elseIf Affection <= -10
		Rank = -1
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " doesn't like you.")
		endif
	endif
	If Affection >= 100
		Rank = 4
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " loves you!")
		endif
	elseIf Affection >= 60
		Rank = 3
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " sees you as a good friend!")
		endif
	elseIf Affection >= 30
		Rank = 2
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " enjoys your company!")
		endif
	elseIf Affection >= 10
		Rank = 1
		ActiveNPC.getActorRef().SetRelationshipRank(playerRef, Rank)
		If MCM.affectionComments == true
			Debug.Notification(Name + " likes you!")
		endif
	endif
	
	if ActiveNPC.getActorRef().isInFaction(RDS_Friendzone) && Rank <= -1
		ActiveNPC.getActorRef().removeFromFaction(RDS_Friendzone)
	endIf
	
	main.NPC_time[pos] = Utility.getCurrentGameTime()		; save the last time we spoke to the npc for cleanup purposes
	
	If (flirtCount/5) > 0
		Main.adjustLocalReputation(flirtCount/5)			 ; player loosed reputation
		
		int dummy = main.NPC_eyeWitness[pos]				 ; rep loss gets saves to the NPC
		dummy += flirtCount/5
		Main.NPC_eyeWitness[pos] = dummy
	endif
	
endfunction

Event OnUpdate()																				; failsafe, aborts the quest when the approach takes over 3 in-game hours OR when the dialogue takes longer than 10 in-game hours
Utility.Wait(0.1)
	If (Utility.GetCurrentGameTime() - Time)*24 >= 3 && self.getStage() == 10
		Stop()
	elseIf (Utility.GetCurrentGameTime() - Time)*24 >= 10 && self.getStage() == 20
		turn = 12
	elseIf SexLab.isActorActive(player)													; check if the player has started a sexlab animation in between the choosing of an NPC and him finishing his approach -> abort the approach
		Stop()
	endif
EndEvent

Function RemoveCunning()
	Main.NPC_Trait1[pos] == ""
endfunction

Function North()
	Y_move += 1
endfunction

Function South()
	Y_move -= 1
endfunction

Function West()
	X_move -= 1
	modPlayerExposure(5)
endfunction

Function East()
	X_move += 1
endfunction

Function NW()
	Y_move += 1
	X_move -= 1
	if mcm.playerSubmission != "submissive"
		modPlayerExposure(7)
	endif
endfunction

Function NE()
	Y_move += 1
	X_move += 1
endfunction

Function SW()
	Y_move -= 1
	X_move -= 1
	if mcm.playerSubmission != "normal"
		modPlayerExposure(7)
	endif
endfunction

Function SE()
	Y_move -= 1
	X_move += 1
endfunction

Function NNE()
	If step
		X_move += 1
	else
		Y_move += 2
	endif
endfunction

Function NNW()
	If step
		X_move -= 1
	else
		Y_move += 2
	endif
endfunction

Function SSW()
	If step
		X_move -= 1
	else
		Y_move -= 2
	endif
endfunction

Function SSE()
	If step
		X_move += 1
	else
		Y_move -= 2
	endif
endfunction

Function EEN()
	If step
		Y_move += 1
	else
		X_move += 2
	endif
endfunction

Function EES()
	If step
		Y_move -= 1
	else
		X_move += 2
	endif
endfunction

Function WWN()
	If step
		Y_move += 1
	else
		X_move -= 2
	endif
	if mcm.playerSubmission != "submissive"
		modPlayerExposure(5)
	endif
endfunction

Function WWS()
	If step
		Y_move -= 1
	else
		X_move -= 2
	endif
	if mcm.playerSubmission != "normal"
		modPlayerExposure(5)
	endif
endfunction

Function modPlayerExposure(int newArousal)
	int Exposure = slaScript.getActorExposure(playerRef)
	exposure += newArousal
	slaScript.setActorExposure(playerRef, exposure)
endFunction

Function changeRelationshipStatus(string newStatus)
	main.NPC_relationshipStatus[pos] = newStatus
endFunction

Function playerIsFlirting()
	string RS = main.NPC_relationshipStatus[pos]
	if RS != "lover" && RS != "FriendWithBenefits" && RS != "partner" 
		if NPCisFlirting
			flirtCount += 2
		else
			flirtCount += 1
		endif
	endif
endFunction
Actor Property Player  Auto  
