Scriptname RDS_HayScript extends ObjectReference  

MiscObject Property requiredItem  Auto  
Idle Property IdleStop_Loose  Auto
ObjectReference Property ObjectToRemove Auto
Float Property offsetDown  Auto
Explosion Property DustEffect  Auto

float mX
float mY
float mZ

Event OnActivate(objectreference ak)

		if (ak).getItemCount(requiredItem) == 0
			Debug.Notification("You need a broom for this!")
		else
			mX = self.GetPositionX()
			mY = self.GetPositionY()
			mZ = self.GetPositionZ()

			self.SetPosition(mX,mY,mZ - offsetDown)
			if ak == game.getplayer()
				game.forceThirdPerson()
			endif
			Debug.SendAnimationEvent((ak), "idleLooseSweepingStart")
			utility.wait(3.0)
			ObjectToRemove.placeatme(DustEffect)
			utility.wait(3.0)
			ObjectToRemove.placeatme(DustEffect)
			utility.wait(3.0)
			ObjectToRemove.placeatme(DustEffect)
			ObjectToRemove.disable(true)
			Debug.SendAnimationEvent((ak), "IdleStop")
			RegisterForSingleUpdateGameTime(Utility.RandomInt(72, 168))
		endif

EndEvent

Event OnUpdateGameTime()
	self.SetPosition(mX,mY,mZ)
	ObjectToRemove.enable(true)
EndEvent