Scriptname RDS_BlockActorScript extends activemagiceffect  

;CONSTANTS
keyword Property ActiveTypeNPC auto
faction Property RDS_Fobidden auto

Event OnEffectStart(Actor akTarget, Actor akCaster)

	if akTarget.hasKeyword(ActiveTypeNPC)
		if akTarget.isInFaction(RDS_Fobidden)
			akTarget.removeFromFaction(RDS_Fobidden)
			debug.Notification( akTarget.getLeveledActorBase().getName() + " is un-blocked again.")
		else
			akTarget.addToFaction(RDS_Fobidden)
			akTarget.setFactionRank(RDS_Fobidden, 1)
			debug.Notification( akTarget.getLeveledActorBase().getName() + " is now blocked for approaches.")
		endif
	endif

endEvent