Scriptname RDS_ConsensScript extends Quest  

SexLabFramework Property SexLab Auto
ReferenceAlias Property ActiveNPC Auto
ObjectReference[] Property Marker  Auto
ObjectReference Property TargetMarker  Auto
float Property Time auto
int Property NPCleads auto
RDS_MCM Property MCM  Auto
RDS_controller property controller auto

Function Action()
	RegisterForModEvent("AnimationEnd_consens", "Finished")

		actor[] sexActors = new actor[2]

		if SexLab.getGender(Game.GetPlayer()) == 1	; sort a female player in the "female" slot
			sexActors[0] = Game.GetPlayer()
			sexActors[1] = (ActiveNPC.GetRef() as Actor)	
		else													; and vice versa
			sexActors[0] = (ActiveNPC.GetRef() as Actor)
			sexActors[1] = Game.GetPlayer()
		endif

		sslBaseAnimation[] anims		

	If NPCleads == 1
		if Utility.RandomInt(0,100) <= MCM.NPCagr
			anims = SexLab.GetAnimationsByTags(2, "Aggressive", RequireAll = false)
			SexLab.StartSex(SexActors, Anims, CenterOn = Targetmarker, AllowBed = true, Hook = "consens")
		else
			SexLab.StartSex(SexActors, Anims, CenterOn = Targetmarker, AllowBed = true, Hook = "consens")
		endif
	else
		SexLab.StartSex(SexActors, Anims, CenterOn = Targetmarker, AllowBed = true, Hook = "consens")
	endif
endfunction

event Finished (string eventName, string argString, float argNum, form sender)
	Stop()
endEvent

Function FindMarker()
	int iCount = 0

	While iCount < 17
		If ActiveNPC.GetRef().GetDistance(Marker[iCount]) <= 2500
			TargetMarker = Marker[iCount]
			iCount = 17
		else
			iCount += 1
		endif
	endWhile
endfunction

Event OnUpdate()
	Utility.Wait(0.1)
	If (Utility.GetCurrentGameTime() - Time)*24 >= 12
		Stop()
	endif
EndEvent

