Scriptname RDS_FWBscript extends Quest  

float property time auto hidden
ReferenceAlias Property Alias_Friend auto
SexLabFramework Property SexLab auto
RDS_MCM Property MCM auto
rds_playerapproachscript Property main auto
Faction Property RDS_FWBfaction auto

Function Action()

	RegisterForModEvent("AnimationEnd_FWB", "Finished")

	if SexLab.getGender(Game.GetPlayer()) == 1																; sort a female player in the "female" slot
		SexLab.Quickstart(Game.GetPlayer(), Alias_Friend.getActorRef(), victim = none, Hook = "FWB")
	else																									; and vice versa
		SexLab.Quickstart(Alias_Friend.getActorRef(), Game.GetPlayer(), victim = none, Hook = "FWB")
	endif

endfunction

event Finished (string eventName, string argString, float argNum, form sender)
																							; animation is done, increase affection and shut down quest
	int pos = main.NPC_ID.find(Alias_Friend.getActorRef())
	int affection = Main.NPC_affection[pos]
	affection += MCM.sexAffection as int
	Main.NPC_affection[pos] = affection

	Alias_Friend.Clear()
	Reset()
	SetStage(0)

endEvent

Event OnUpdate()   																							; failsafe timer
	Utility.Wait(0.1)
	If (Utility.GetCurrentGameTime() - Time)*24 >= 12											; if the whole approach takes longer than 12 in-game hours abort quest
		Alias_Friend.Clear()
		Reset()
		SetStage(0)
	endif
EndEvent

Function AddActor(actor NPC)

	NPC.AddToFaction(RDS_FWBfaction)														; faction needed as dialogue condition
	NPC.SetFactionRank(RDS_FWBfaction, 1)

	int pos = main.NPC_ID.find(NPC)
	Main.NPC_relationshipStatus[pos] = "friendsWithBenefits"
endfunction