Scriptname RDS_MCM extends SKI_ConfigBase conditional

int ONOID
int approachToggleOID

int NPCnameOID
int NPCpersOID
int NPCaffOID
int NPCtraitOID
int NPCMoodOID
int NPCsexOID

int XOID
int YOID
int PurgeOID
int delOID
int filteredPurgeOID

int NPCpersCOID
int NPCaffCOID
int NPCtraitCOID
int NPCsexCOID
int persIndex
int affIndex
int traitIndex
int sexIndex
int sexdistIndex
int behaviorIndex
int outfitFlagIndex

int sexualityCommentsOID
int moodCommentsOID
int cheatingCommentsOID
int witnessedCommentsOID
int reputationStatusCommentsOID
int affectionCommentsOID

int empty1OID
int empty2OID
int empty3OID
int empty4OID
int empty5OID
int empty6OID
int empty7OID
int empty8OID
int empty9OID
int empty10OID
int empty11OID
int empty12OID

int rep1OID
int rep2OID
int rep3OID
int rep4OID
int rep5OID
int rep6OID
int rep7OID
int rep8OID
int rep9OID
int rep0OID

String[] pers
String[] trait1
String[] sex
String[] sexdist1
String[] behaviorTypes
String[] outfitFlags
String[] NPCrelStatArray

int minArsSexOID
int NPCfightOID
int FleeGoldOID
int FleeSexOID
int NPCagrOID
int PCsexAgrOID
int NPCdialOID
int cooldownOID
int traitOID
int sexdistOID
int apprGenOID
int eyeWitOID
int earWitOID
int dialChanOID
int loverRepOID
int vicRepOID
int vicCheatOID
int comWitOID
int houWitOID
int comLovOID
int houLovOID
int behOID
int bodyOutfitOID
int outfitFlagOID
int sexAffectionOID
int approachSexualityOID
int nudeWitnessOID
int traitWeightPervertedOID
int traitWeightAbusiveOID
int traitWeightCruelOID
int traitWeightColdOID
int traitWeightCunningOID
int traitWeightCharmingOID
int traitWeightRomanticOID
int traitWeightLowSelfEsteemOID
int traitWeightPrudeOID

int negativeAffectionLimitOID
int positiveAffectionLimitOID
int unmatchingSexualityOID
int flirtLimitOID
int nonFlirtLimitOID
int sexDemandLimitOID
int sexInviteLimitOID
int playerSubmissionOID
int NPC_dialogueCooldownOID
int NPCRelStatOID
int NPCrelStatListOID

int reset1OID
int reset2OID
int reset3OID
int reset4OID
int reset5OID
int reset6OID
int reset7OID
int reset8OID
int reset0OID

int dirtOID
int litterOID
int foreplayOID
int rapeNudeWitnessOID
int fzCooldownOID

int property dialogueCooldown = 0 auto conditional ; helping variable for the player approach dialogue, not MCM related
bool property ON = true auto conditional
string property Purge = "Purge?" auto
GlobalVariable Property RDS_X auto
GlobalVariable Property RDS_Y auto
GlobalVariable Property RDS_minArsSex auto
GlobalVariable Property RDS_NPCfleeGold auto
GlobalVariable Property RDS_NPCfleeSex auto
GlobalVariable Property RDS_NPCdial auto
GlobalVariable Property RDS_NPCcombat auto
GlobalVariable Property RDS_NPCapproachcooldown auto

string property NPCname = "" auto
string property NPCpers = "" auto
string property NPCaff = "" auto
string property NPCtrait = "" auto
string property NPCmood = "" auto
string property NPCsex = "" auto

string property NPCpersC  = "" auto
float property NPCaffC = 0.0 auto
string property NPCtraitC = "" auto
string property NPCsexC = "" auto

bool property sexualityComments = true auto
bool property moodComments = true auto
bool property cheatingComments = true auto
bool property witnessedComments = true auto
bool property reputationStatusComments = true auto
bool property affectionComments = true auto

float property X auto
float property Y auto
float property del = 30.0 auto

float property minArsSex = 40.0 auto conditional
float property NPCfight = 50.0 auto conditional
float property FleeGold = 25.0 auto conditional
float property FleeSex = 25.0 auto conditional
float property NPCagr = 80.0 auto
float property PCSexagr = 80.0 auto

float property NPCdial = 50.0 auto conditional
float property oldCooldown = 0.0 auto				; helping variable
float property cooldown = 3.0 auto					; general cooldown for all kinds of scenes
string property sexdist = "equally" auto
float property trait = 33.0 auto

RDS_controller Property controller auto
RDS_PlayerApproachScript Property RDS auto
RDS_NPCapproachScript Property Main auto
Quest Property RDS_DialogueQuest auto
Quest Property RDS_PlayerApproach auto

string Property approachGender = "both" auto
float property eyeWitness = 3.0 auto
float property earWitness = 1.0 auto
float property dialogueChance = 30.0 auto
float property loverReputation = 1.0 auto
bool property victimReputation = false auto
bool property victimCheating = false auto
bool property companionWitness = true auto
bool property companionLover = true auto
bool property housecarlWitness = false auto
bool property housecarlLover = true auto
string property behavior = "friendly" auto
string property outfitFlag = "" auto
string property bodyOutfit = "" auto
float property sexAffection = 5.0 auto
string property approachSexuality = "unspecified" auto
float property nudeWitness = 2.0 auto

float property traitWeightPerverted = 1.0 auto
float property traitWeightAbusive = 1.0 auto
float property traitWeightCruel = 1.0 auto
float property traitWeightCold = 1.0 auto
float property traitWeightCunning = 1.0 auto
float property traitWeightCharming = 1.0 auto
float property traitWeightRomantic = 1.0 auto
float property traitWeightLowSelfEsteem = 1.0 auto
float property traitWeightPrude = 1.0 auto

float property negativeAffectionLimit = 10.0 auto
float property positiveAffectionLimit = 40.0 auto
bool property unmatchingSexuality = true auto conditional
float property flirtLimit = 20.0 auto
float property nonFlirtLimit = 70.0 auto
float property sexDemandLimit = 50.0 auto
float property sexInviteLimit = 30.0 auto

GlobalVariable property RDS_negativeAffection auto
GlobalVariable property RDS_positiveAffection auto
GlobalVariable property RDS_flirtLimit auto
GlobalVariable property RDS_nonFlirtLimit auto
GlobalVariable property RDS_sexDemand auto
GlobalVariable property RDS_sexInvite auto

string property playerSubmission = "normal" auto
float property NPC_dialogueCooldown = 1.0 auto
string property NPCrelStatList auto 
int property relstatIndex auto
string property NPCrelStat auto
string property approachToggle = "all NPC" auto
bool property filteredPurge = true auto
faction property RDS_Partner auto
RDS_RelationshipScript property RelationshipScript auto

actor Property debugActor auto
int Property pos auto

string property reset1 = "Reset?" auto
string property reset2 = "Reset?" auto
string property reset3 = "Reset?" auto
string property reset4 = "Reset?" auto
string property reset5 = "Reset?" auto
string property reset6 = "Reset?" auto
string property reset7 = "Reset?" auto
string property reset8 = "Reset?" auto
string property reset0 = "Reset?" auto

bool property dirt = true auto
bool property litter = true auto
bool property foreplay = false auto
bool property rapeNudeWitness = false auto
float property fzCooldown = 5.0 auto

event OnConfigInit()
	Pages = new string[2]
	Pages[0] = "Settings"
	Pages[1] = "Debug"

	pers = new string[5]
	pers[0] = "Choleric"
	pers[1] = "Confidant"
	pers[2] = "Realist"
	pers[3] = "Sophisticated"
	pers[4] = "Shy"

	trait1 = new String[9]
	trait1[0] = "perverted"
	trait1[1] = "cruel"
	trait1[2] = "prude"
	trait1[3] = "low self-esteem"
	trait1[4] = "cold"
	trait1[5] = "cunning"
	trait1[6] = "romantic"
	trait1[7] = "abusive"
	trait1[8] = "charming"

	sex = new String[3]	
	sex[0] = "hetero"
	sex[1] = "homo"
	sex[2] = "bi"

	sexdist1 = new string[10]
	sexdist1[0] = "all hetero"
	sexdist1[1] = "all homo"
	sexdist1[2] = "all bi"
	sexdist1[3] = "equally"
	sexdist1[4] = "2/3 hetero"
	sexdist1[5] = "2/3 homo"
	sexdist1[6] = "2/3 bi"
	sexdist1[7] = "3/4 hetero"
	sexdist1[8] = "3/4 homo"
	sexdist1[9] = "3/4 bi"
	
	behaviorTypes = new string[6]
	behaviorTypes[0] = "shy"
	behaviorTypes[1] = "cute"
	behaviorTypes[2] = "flirty"
	behaviorTypes[3] = "friendly"
	behaviorTypes[4] = "cold"
	behaviorTypes[5] = "posh"
	
	outfitFlags = new string[5]
	outfitFlags[0] = "covering"
	outfitFlags[1] = "normal"
	outfitFlags[2] = "revealing"
	outfitFlags[3] = "skimpy"
	outfitFlags[4] = "naked"
	
	NPCrelStatArray = new string[5]
	NPCrelStatArray[0] = "Stanger"
	NPCrelStatArray[1] = "Lover"
	NPCrelStatArray[2] = "Partner"
	NPCrelStatArray[3] = "friendsWithBenefits"
	NPCrelStatArray[4] = "Friendzone"
	
endevent

event OnPageReset(string Page)

if page == "Settings"

	Purge = "Purge?"

	SetCursorFillMode(TOP_TO_BOTTOM)

	AddHeaderOption("SexLab Relationship Dialogue System")
	AddHeaderOption("by Guffel")
	AddEmptyOption()

	If ON == true
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(6)

		OnOID = AddToggleOption("Mod On/ Off:", On)
		approachToggleOID = AddTextOption("Approach setting:", approachToggle)
		
		AddEmptyOption()
		AddHeaderOption("General:")
		
		; general
		CooldownOID = AddSliderOption("Approach cooldown:", cooldown, "{1}")		
		NPC_dialogueCooldownOID = AddSliderOption("NPC dialogue cooldown:", NPC_dialogueCooldown, "{1}")
		dialChanOID = AddSliderOption("Dialogue-Scene Chance:", dialogueChance, "{1} %")
		NPCdialOID = AddSliderOption("Dialogue accept chance:", NPCdial, "{1} %")
		behOID = AddMenuOption("How does your character behave?", behavior)
		playerSubmissionOID = AddTextOption("Player obedience level:", playerSubmission)
		apprGenOID = AddTextOption("Approach Gender:", approachGender)
		approachSexualityOID = AddTextOption("Approach Sexuality:", approachSexuality)
		negativeAffectionLimitOID = AddSliderOption("Aggressive affection threshold: ", negativeAffectionLimit, "{1}")
		positiveAffectionLimitOID = AddSliderOption("Romantic affection threshold: ", positiveAffectionLimit, "{1}")
		unmatchingSexualityOID = AddToggleOption("Block hook-ups for unfitting sexuality: ", unmatchingSexuality)
		flirtLimitOID = AddSliderOption("Flirt arousal limit: ", flirtLimit, "{1}")
		nonFlirtLimitOID = AddSliderOption("Non-Flirt arousal limit: ", nonFlirtLimit, "{1}")
		sexDemandLimitOID = AddSliderOption("Sex demand arousal limit: ", sexDemandLimit, "{1}")
		sexInviteLimitOID = AddSliderOption("Sex invite arousal limit: ", sexInviteLimit, "{1}")
		PCSexagrOID = AddSliderOption("Sex demands use aggr. animations:", PCsexAgr, "{1} %")
		delOID = AddSliderOption("Days before auto-delete NPC:", del, "{1}")
		filteredPurgeOID = AddToggleOption("Filtered Purge:", filteredPurge)
		PurgeOID = AddTextOption("Clear all saved NPC: ", Purge)
		dirtOID = AddToggleOption("Player House Dirt: ", dirt)
		litterOID = AddToggleOption("Partner Littering: ", litter)
		
		AddEmptyOption()
		AddHeaderOption("NPC:")
		
		; NPC 
		sexdistOID = AddMenuOption("NPC sexuality distribution:", sexdist)
		NPCfightOID = AddSliderOption("NPC starts fight:", NPCfight, "{1} %")
		FleeGoldOID = AddSliderOption("NPC flees on gold demand:", fleeGold, "{1} %")
		FleeSexOID = AddSliderOption("NPC flees on sex demand:", fleeSex, "{1} %")
		fzCooldownOID = AddSliderOption("Friendzone Cooldown:", fzCooldown, "{1}")
		
		AddEmptyOption()
		AddHeaderOption("Trait:")
		
		; Traits
		traitOID = AddSliderOption("NPC trait chance: ", trait, "{1} %")
		traitWeightPervertedOID = AddSliderOption("Perverted weight: ", traitWeightPerverted, "{1}")
		traitWeightAbusiveOID = AddSliderOption("Abusive weight: ", traitWeightAbusive, "{1}")
		traitWeightCruelOID = AddSliderOption("Cruel weight: ", traitWeightCruel, "{1}")
		traitWeightColdOID = AddSliderOption("Cold weight: ", traitWeightCold, "{1}")
		traitWeightCunningOID = AddSliderOption("Cunning weight: ", traitWeightCunning, "{1}")
		traitWeightCharmingOID = AddSliderOption("Charming weight: ", traitWeightCharming, "{1}")
		traitWeightRomanticOID = AddSliderOption("Romantic weight: ", traitWeightRomantic, "{1}")
		traitWeightLowSelfEsteemOID = AddSliderOption("Low self-esteem weight: ", traitWeightLowSelfEsteem, "{1}")
		traitWeightPrudeOID = AddSliderOption("Prude weight: ", traitWeightPrude, "{1}")
		
		SetCursorPosition(7)
		AddEmptyOption()
		AddHeaderOption("Sex:")
		
		; sex
		minArsSexOID = AddSliderOption("Arousal to accept sex:", minArsSex, "{1}")
		sexAffectionOID = AddSliderOption("Affection gain on sex:", sexAffection, "{1}")
		NPCagrOID = AddSliderOption("NPC uses aggr. animations:", NPCagr, "{1} %")
		
		AddEmptyOption()
		AddHeaderOption("Comments:")
		
		; comments
		moodCommentsOID = AddToggleOption("NPC Mood comments:", moodComments)
		affectionCommentsOID = AddToggleOption("NPC Affection comments:", affectionComments)
		sexualityCommentsOID = AddToggleOption("NPC Sexuality comments:", sexualityComments)
		cheatingCommentsOID = AddToggleOption("Comments when cheating:", cheatingComments)
		reputationStatusCommentsOID = AddToggleOption("Comments when reputation changes:", reputationStatusComments)
		witnessedCommentsOID = AddToggleOption("Comments when witnessed:", witnessedComments)

		
		AddEmptyOption()
		AddHeaderOption("Armor:")
		
		; armor
		armor wornArmor = game.GetPlayer().GetWornForm(0x00000004) as Armor
		bodyOutfit = wornArmor.getName()
		int Z = bodyArmorStorage.find(wornArmor)
		if Z < 0
			outfitFlag = "normal"
		else
			outfitFlag = bodyArmorFlagStorage[Z]
		endif
		bodyOutfitOID = AddTextOption("Currently equipped armor:", bodyOutfit)
		outfitFlagOID = AddMenuOption("Armor set as:", outfitFlag)
		
		AddEmptyOption()
		AddHeaderOption("Witness:")
		
		; witness
		eyeWitOID = AddSliderOption("Eye Witness Penalty:", eyeWitness, "{1}")
		earWitOID = AddSliderOption("Ear Witness Penalty:", earWitness, "{1}")
		nudeWitnessOID = AddSliderOption("Nude Witness Penalty:", nudeWitness, "{1}")
		foreplayOID = AddToggleOption("Ignore foreplay animations:", foreplay)
		rapeNudeWitnessOID = AddToggleOption("Ignore witnesses when raped:", rapeNudeWitness)
		
		AddEmptyOption()
		AddHeaderOption("Reputation:")
		
		; reputation
		loverRepOID = AddSliderOption("Rep penalty per lover:", loverReputation, "{1}")
		vicRepOID = AddToggleOption("Rape reduces Reputation:", victimReputation)
		vicCheatOID = AddToggleOption("Rape counts as cheating:", victimCheating)
		houLovOID = AddToggleOption("Housecarls are no lovers", housecarlLover)
        houWitOID = AddToggleOption("Housecarls are no witnesses", housecarlWitness)
        comLovOID = AddToggleOption("Companions are no lovers", companionLover)
        comWitOID = AddToggleOption("Companions are no witnesses", companionWitness)
		
	else
		OnOID = AddToggleOption("Mod On/ Off:", On)
	endif
elseif page == "Debug"

	NPCpers = RDS.NPC_personality[pos]
	NPCtrait = RDS.NPC_trait1[pos]
	NPCsex = RDS.NPC_sexuality[pos]
	NPCaff = RDS.NPC_affection[pos]
	NPCrelStat = RDS.NPC_relationshipStatus[pos]
	NPCname = debugActor.GetLeveledActorBase().GetName()
	NPCpersC = ""
	NPCtraitC = ""
	NPCsexC = ""
	NPCaffC = 0.0
	
	If RDS_DialogueQuest.isRunning() == true
		X = RDS_X.GetValue()
		Y = RDS_Y.GetValue()
	endif

	SetCursorFillMode(TOP_TO_BOTTOM)

	If ON == true
		NPCnameOID = AddTextOption("Active NPC: ", NPCname)

		AddEmptyOption()

		NPCpersOID  = AddTextOption("Personality: ", NPCpers)
		NPCpersCOID  = AddMenuOption("Change Personality: ", NPCpersC)

		NPCtraitOID = AddTextOption("Trait:", NPCtrait)
		NPCtraitCOID = AddMenuOption("Change Trait:", NPCtraitC)

		NPCsexOID = AddTextOption("Sexuality:", NPCsex)
		NPCsexCOID = AddMenuOption("Change Sexuality:", NPCsexC)

		NPCAffOID = AddTextOption("Affection:", NPCaff)
		NPCAffCOID = AddSliderOption("Change Affection:", NPCaffC, "{1}")
		
		NPCRelStatOID = AddTextOption("Relationship Status:", NPCrelStat)
		NPCrelStatListOID = AddMenuOption("Change Rel. Stat.: ", NPCrelStatList)
		

		AddEmptyOption()
	
		xOID = AddTextOption("X:", X)
		yOID = AddTextOption("Y:", Y)

		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(1)

		reset1 = "Reset?"
		reset2 = "Reset?"
		reset3 = "Reset?"
		reset4 = "Reset?"
		reset5 = "Reset?"
		reset6 = "Reset?"
		reset7 = "Reset?"
		reset8 = "Reset?"
		reset0 = "Reset?"

		AddHeaderOption("Player Reputation Info:")
		rep1OID = AddTextOption("Reputation Eastmarch:", RDS.eastmarch_reputation)
		reset1OID = AddTextOption("Reset Eastmarch:", reset1)
		rep2OID = AddTextOption("Reputation Falkreath:", RDS.falkreath_reputation)
		reset2OID = AddTextOption("Reset Falkreath:", reset2)
		rep3OID = AddTextOption("Reputation Haarfingar:", RDS.haarfingar_reputation)
		reset3OID = AddTextOption("Reset Haarfingar:", reset3)
		rep4OID = AddTextOption("Reputation Hjaalmarch:", RDS.hjaalmarch_reputation)
		reset4OID = AddTextOption("Reset Hjaalmarch:", reset4)
		rep5OID = AddTextOption("Reputation The Pale:", RDS.pale_reputation)
		reset5OID = AddTextOption("Reset The Pale:", reset5)
		rep6OID = AddTextOption("Reputation Reach:", RDS.reach_reputation)
		reset6OID = AddTextOption("Reset Reach:", reset6)
		rep7OID = AddTextOption("Reputation Rift:", RDS.rift_reputation)
		reset7OID = AddTextOption("Reset Rift:", reset7)
		rep8OID = AddTextOption("Reputation Whiterun:", RDS.whiterun_reputation)
		reset8OID = AddTextOption("Reset Whiterun:", reset8)
		rep0OID = AddTextOption("Reputation Winterhold:", RDS.winterhold_reputation)
		reset0OID = AddTextOption("Reset Winterhold:", reset0)

		AddEmptyOption()
		AddHeaderOption("Trait Info:")
		AddEmptyOption()

		string emptyString = ""
		empty2OID = AddTextOption("perverted", emptyString)
		empty3OID = AddTextOption("cruel", emptyString)
		empty4OID = AddTextOption("prude", emptyString)
		empty5OID = AddTextOption("low self-esteem", emptyString)
		empty6OID = AddTextOption("cold", emptyString)
		empty7OID = AddTextOption("cunning", emptyString)
		empty8OID = AddTextOption("romantic", emptyString)
		empty9OID = AddTextOption("abusive", emptyString)
		empty10OID = AddTextOption("charming", emptyString)

	endif
endif
endevent

Event OnOptionSliderOpen(Int Option)
	if option == traitOID
		SetSliderDialogStartValue(trait)
		SetSliderDialogDefaultValue(33.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == NPCdialOID
		SetSliderDialogStartValue(NPCdial)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == CoolDownOID
		SetSliderDialogStartValue(Cooldown)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(0.0, 72.0)
		SetSliderDialogInterval(1.0)
	elseif option == minArsSexOID
		SetSliderDialogStartValue(minArsSex)
		SetSliderDialogDefaultValue(40.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == NPCFightOID
		SetSliderDialogStartValue(NPCfight)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == fleegoldOID
		SetSliderDialogStartValue(fleegold)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == fleesexOID
		SetSliderDialogStartValue(fleesex)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == NPCagrOID
		SetSliderDialogStartValue(NPCagr)
		SetSliderDialogDefaultValue(80.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == PCsexAgrOID
		SetSliderDialogStartValue(PCsexagr)
		SetSliderDialogDefaultValue(80.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == NPCaffCOID
		SetSliderDialogStartValue(NPCaffC)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == delOID
		SetSliderDialogStartValue(del)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(0.0, 300.0)
		SetSliderDialogInterval(1.0)
	elseif option == eyeWitOID
		SetSliderDialogStartValue(eyeWitness)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == earWitOID
		SetSliderDialogStartValue(earWitness)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == dialChanOID
		SetSliderDialogStartValue(dialogueChance)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == loverRepOID
		SetSliderDialogStartValue(loverReputation)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == sexAffectionOID
		SetSliderDialogStartValue(sexAffection)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == nudeWitnessOID
		SetSliderDialogStartValue(nudeWitness)
		SetSliderDialogDefaultValue(2.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightPervertedOID
		SetSliderDialogStartValue(traitWeightPerverted)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightAbusiveOID
		SetSliderDialogStartValue(traitWeightAbusive)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightCruelOID
		SetSliderDialogStartValue(traitWeightCruel)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightColdOID
		SetSliderDialogStartValue(traitWeightCold)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightCunningOID
		SetSliderDialogStartValue(traitWeightCunning)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightCharmingOID
		SetSliderDialogStartValue(traitWeightCharming)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightRomanticOID
		SetSliderDialogStartValue(traitWeightRomantic)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightLowSelfEsteemOID
		SetSliderDialogStartValue(traitWeightLowSelfEsteem)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == traitWeightPrudeOID
		SetSliderDialogStartValue(traitWeightPrude)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(1.0)
	elseif option == negativeAffectionLimitOID
		SetSliderDialogStartValue(negativeAffectionLimit)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == positiveAffectionLimitOID
		SetSliderDialogStartValue(positiveAffectionLimit)
		SetSliderDialogDefaultValue(40.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == flirtLimitOID
		SetSliderDialogStartValue(flirtLimit)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == nonFlirtLimitOID
		SetSliderDialogStartValue(nonFlirtLimit)
		SetSliderDialogDefaultValue(70.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == sexDemandLimitOID
		SetSliderDialogStartValue(sexDemandLimit)
		SetSliderDialogDefaultValue(40.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == sexInviteLimitOID
		SetSliderDialogStartValue(sexInviteLimit)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	elseif option == NPC_dialogueCooldownOID
		SetSliderDialogStartValue(NPC_dialogueCooldown)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 72.0)
		SetSliderDialogInterval(1.0)
	elseif option == fzCooldownOID
		SetSliderDialogStartValue(fzCooldown)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 120.0)
		SetSliderDialogInterval(1.0)
	endif
endevent

Event OnOptionSliderAccept(Int Option, Float value)
	If Option == traitOID
		trait = value
		SetSliderOptionValue(traitOID, trait, "{1}")
	elseIf Option == NPCdialOID
		NPCdial = value
		RDS_NPCdial.SetValue(NPCdial)
		SetSliderOptionValue(NPCdialOID, NPCdial, "{1} %")
	elseIf Option == CoolDownOID
		oldCooldown = Cooldown
		CoolDown = value
		float time = RDS_NPCapproachcooldown.getValue()
		time - (oldCooldown/24)
		time + (Cooldown/24)
		RDS_NPCapproachcooldown.SetValue(time)
		SetSliderOptionValue(CoolDownOID, CoolDown, "{1}")		
	elseIf Option == minArsSexOID
		minArsSex = value
		RDS_minArsSex.SetValue(minArsSex)
		SetSliderOptionValue(minArsSexOID, minArsSex, "{1}")
	elseIf Option == NPCfightOID
		NPCfight = value
		RDS_NPCCombat.SetValue(NPCfight)
		SetSliderOptionValue(NPCfightOID, NPCfight, "{1}")
	elseIf Option == fleegoldOID
		fleegold = value
		RDS_NPCfleeGold.SetValue(fleeGold)
		SetSliderOptionValue(fleegoldOID, fleegold, "{1}")
	elseIf Option == fleesexOID
		fleesex = value
		RDS_NPCfleeSex.SetValue(fleeSex)
		SetSliderOptionValue(fleesexOID, fleesex, "{1}")
	elseIf Option == NPCagrOID
		NPCagr = value
		SetSliderOptionValue(NPCagrOID, NPCagr, "{1}")
	elseIf Option == PCsexagrOID
		PCsexagr = value
		SetSliderOptionValue(PCsexagrOID, PCsexagr, "{1}")
	elseIf Option == NPCaffCOID
		NPCaffC = value
		SetSliderOptionValue(NPCaffCOID, NPCaffC, "{1}")
		if debugActor != none
			RDS.NPC_affection[pos] = NPCaffC as Int
			ForcePageReset()
		endif
	elseIf Option == delOID
		del = value
		SetSliderOptionValue(delOID, del, "{1}")
	elseIf Option == dialChanOID
		dialogueChance = value
		SetSliderOptionValue(dialChanOID, dialogueChance, "{1} %")
	elseIf Option == eyeWitOID
		eyeWitness = value
		SetSliderOptionValue(eyeWitOID, eyeWitness, "{1}")
	elseIf Option == earWitOID
		earWitness = value
		SetSliderOptionValue(earWitOID, earWitness, "{1}")
	elseIf Option == loverRepOID
		loverReputation = value
		SetSliderOptionValue(loverRepOID, loverReputation, "{1}")
	elseIf Option == sexAffectionOID
		sexAffection = value
		SetSliderOptionValue(sexAffectionOID, sexAffection, "{1}")
	elseIf Option == nudeWitnessOID
		nudeWitness = value
		SetSliderOptionValue(nudeWitnessOID, nudeWitness, "{1}")
	elseIf Option == traitWeightPervertedOID
		traitWeightPerverted = value
		SetSliderOptionValue(traitWeightPervertedOID, traitWeightPerverted, "{1}")
	elseIf Option == traitWeightAbusiveOID
		traitWeightAbusive = value
		SetSliderOptionValue(traitWeightAbusiveOID, traitWeightAbusive, "{1}")
	elseIf Option == traitWeightCruelOID
		traitWeightCruel = value
		SetSliderOptionValue(traitWeightCruelOID, traitWeightCruel, "{1}")
	elseIf Option == traitWeightColdOID
		traitWeightCold = value
		SetSliderOptionValue(traitWeightColdOID, traitWeightCold, "{1}")
	elseIf Option == traitWeightCunningOID
		traitWeightCunning = value
		SetSliderOptionValue(traitWeightCunningOID, traitWeightCunning, "{1}")
	elseIf Option == traitWeightCharmingOID
		traitWeightCharming = value
		SetSliderOptionValue(traitWeightCharmingOID, traitWeightCharming, "{1}")
	elseIf Option == traitWeightRomanticOID
		traitWeightRomantic = value
		SetSliderOptionValue(traitWeightRomanticOID, traitWeightRomantic, "{1}")
	elseIf Option == traitWeightLowSelfEsteemOID
		traitWeightLowSelfEsteem = value
		SetSliderOptionValue(traitWeightLowSelfEsteemOID, traitWeightLowSelfEsteem, "{1}")
	elseIf Option == traitWeightPrudeOID
		traitWeightPrude = value
		SetSliderOptionValue(traitWeightPrudeOID, traitWeightPrude, "{1}")
	elseIf Option == negativeAffectionLimitOID
		negativeAffectionLimit = value
		RDS_negativeAffection.setValue(value)
		SetSliderOptionValue(negativeAffectionLimitOID, negativeAffectionLimit, "{1}")
	elseIf Option == positiveAffectionLimitOID
		positiveAffectionLimit = value
		RDS_positiveAffection.setValue(value)
		SetSliderOptionValue(positiveAffectionLimitOID, positiveAffectionLimit, "{1}")
	elseIf Option == flirtLimitOID
		flirtLimit = value
		RDS_flirtLimit.setValue(value)
		SetSliderOptionValue(flirtLimitOID, flirtLimit, "{1}")
	elseIf Option == nonFlirtLimitOID
		nonFlirtLimit = value
		RDS_nonFlirtLimit.setValue(value)
		SetSliderOptionValue(nonFlirtLimitOID, nonFlirtLimit, "{1}")
	elseIf Option == sexDemandLimitOID
		sexDemandLimit = value
		RDS_sexDemand.setValue(value)
		SetSliderOptionValue(sexDemandLimitOID, sexDemandLimit, "{1}")
	elseIf Option == sexInviteLimitOID
		sexInviteLimit = value
		RDS_sexInvite.setValue(value)
		SetSliderOptionValue(sexInviteLimitOID, sexInviteLimit, "{1}")
	elseIf Option == NPC_dialogueCooldownOID
		NPC_dialogueCooldown = value
		SetSliderOptionValue(NPC_dialogueCooldownOID, NPC_dialogueCooldown, "{1}")
	elseIf Option == fzCooldownOID
		fzCooldown = value
		SetSliderOptionValue(fzCooldownOID, fzCooldown, "{1}")
	endif
endevent

event OnOptionSelect(int option)
	if (option == ONOID)
		ON = !ON
		SetToggleOptionValue(ONOID, ON)
		forcepagereset()
	elseif (option == PurgeOID)
		Purge = "Done!"
		RDS.ThePurge()
		SetTextOptionValue(PurgeOID, Purge)
	elseif (option == filteredPurgeOID)
		filteredPurge = !filteredPurge
		SetTextOptionValue(filteredPurgeOID, filteredPurge)
	elseif (option == sexualityCommentsOID)
		sexualityComments = !sexualityComments
		SetToggleOptionValue(sexualityCommentsOID, sexualityComments)
	elseif (option == moodCommentsOID)
		moodComments = !moodComments
		SetToggleOptionValue(moodCommentsOID, moodComments)
	elseif (option == affectionCommentsOID)
		 affectionComments = !affectionComments
		SetToggleOptionValue(affectionCommentsOID, affectionComments)
	elseif (option == cheatingCommentsOID)
		cheatingComments = !cheatingComments
		SetToggleOptionValue(cheatingCommentsOID, cheatingComments)
	elseif (option == witnessedCommentsOID)
		witnessedComments = !witnessedComments
		SetToggleOptionValue(witnessedCommentsOID, witnessedComments)
	elseif (option == reputationStatusCommentsOID)
		reputationStatusComments = !reputationStatusComments
		SetToggleOptionValue(reputationStatusCommentsOID, reputationStatusComments)
	elseif (option == unmatchingSexualityOID)
		 unmatchingSexuality = !unmatchingSexuality
		SetToggleOptionValue(unmatchingSexualityOID, unmatchingSexuality)
	elseif (option == apprGenOID)
		if approachGender == "male"
			approachGender = "female"
		elseif approachGender == "female"
			approachGender = "both"
		else
			approachGender = "male"
		endif
		SetTextOptionValue(apprGenOID, approachGender)
	elseif (option == approachSexualityOID)
		if approachSexuality == "hetero"
			approachSexuality = "hetero + bi"
		elseif approachSexuality == "hetero + bi"
			approachSexuality = "homo"
		elseif approachSexuality == "homo"
			approachSexuality = "homo + bi"
		elseif approachSexuality == "homo + bi"
			approachSexuality = "bi"
		elseif approachSexuality == "bi"
			approachSexuality = "unspecified"
		else
			approachSexuality = "hetero"
		endif
		SetTextOptionValue(approachSexualityOID, approachSexuality)
	elseif (option == vicRepOID)
		victimReputation = !victimReputation
		SetToggleOptionValue(vicRepOID, victimReputation)
	elseif (option == vicCheatOID)
		victimCheating = !victimCheating
		SetToggleOptionValue(vicCheatOID, victimCheating)
	elseif (option == houLovOID)
		housecarlLover = !housecarlLover
		SetToggleOptionValue(houLovOID, housecarlLover)
	elseif (option == houWitOID)
		 housecarlWitness = !housecarlWitness
		SetToggleOptionValue(houWitOID, housecarlWitness)
    elseif (option == comLovOID)
        companionLover = !companionLover
        SetToggleOptionValue(comLovOID, companionLover)
    elseif (option == comWitOID)
        companionWitness = !companionWitness
        SetToggleOptionValue(comWitOID, companionWitness)
	elseif (option == playerSubmissionOID)
		if playerSubmission == "normal"
			playerSubmission = "submissive"
		elseif playerSubmission == "submissive"
			playerSubmission = "switcher"
		else
			playerSubmission = "normal"
		endif
		SetTextOptionValue(playerSubmissionOID, playerSubmission)
	elseif (option == approachToggleOID)
		if approachToggle == "all NPC"
			approachToggle = "only partners and FWB"
		elseif approachToggle == "only partners and FWB"
		approachToggle = "No approaches"
		else
			approachToggle = "all NPC"
		endif
		SetTextOptionValue(approachToggleOID, approachToggle)
	elseIf (option == reset1OID)
		reset1 = "Done!"
		RDS.eastmarch_reputation = 100
		SetTextOptionValue(reset1OID, reset1)
	elseIf (option == reset2OID)
		reset2 = "Done!"
		RDS.falkreath_reputation = 100
		SetTextOptionValue(reset2OID, reset2)
	elseIf (option == reset3OID)
		reset3 = "Done!"
		RDS.haarfingar_reputation = 100
		SetTextOptionValue(reset3OID, reset3)
	elseIf (option == reset4OID)
		reset4 = "Done!"
		RDS.hjaalmarch_reputation = 100
		SetTextOptionValue(reset4OID, reset4)
	elseIf (option == reset5OID)
		reset5 = "Done!"
		RDS.pale_reputation = 100
		SetTextOptionValue(reset5OID, reset5)
	elseIf (option == reset6OID)	
		reset6 = "Done!"
		RDS.reach_reputation = 100
		SetTextOptionValue(reset6OID, reset6)
	elseIf (option == reset7OID)
		reset7 = "Done!"
		RDS.rift_reputation = 100
		SetTextOptionValue(reset7OID, reset7)
	elseIf (option == reset8OID)
		reset8 = "Done!"
		RDS.whiterun_reputation = 100
		SetTextOptionValue(reset8OID, reset8)
	elseIf (option == reset0OID)
		reset0 = "Done!"
		RDS.winterhold_reputation = 100
		SetTextOptionValue(reset0OID, reset0)
	elseif (option == dirtOID)
		dirt = !dirt
		SetToggleOptionValue(dirtOID, dirt)
		if !dirt
			RelationshipScript.disableDirt()
		else
			RelationshipScript.enableDirt()
		endif
	elseif (option == litterOID)
		litter = !litter
		SetToggleOptionValue(litterOID, litter)
	elseIf (option == foreplayOID)
		foreplay = !foreplay
		SetToggleOptionValue(foreplayOID, foreplay)
	elseIf (option == rapeNudeWitnessOID)
		rapeNudeWitness = !rapeNudeWitness
		SetToggleOptionValue(rapeNudeWitnessOID, rapeNudeWitness)
	endif
endevent

event OnOptionMenuOpen(int a_option)
	if (a_option == sexdistOID) 
		SetMenuDialogStartIndex(sexdistIndex)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(sexdist1)
	elseIf (a_option == NPCsexCOID)
		SetMenuDialogStartIndex(sexIndex)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(sex)
	elseIf(a_option == NPCpersCOID)
		SetMenuDialogStartIndex(persIndex)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(pers)
	elseif (a_option == NPCtraitCOID)
		SetMenuDialogStartIndex(traitIndex)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(trait1)
	elseif (a_option == behOID)
		SetMenuDialogStartIndex(behaviorIndex)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(behaviorTypes)
	elseif (a_option == outfitFlagOID)
		SetMenuDialogStartIndex(outfitFlagIndex)		
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(outfitFlags)
	elseif (a_option == NPCrelStatListOID)
		SetMenuDialogStartIndex(relstatIndex)		
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(NPCrelStatArray)
	endif
endEvent

event OnOptionMenuAccept(int a_option, int a_index)
	if (a_option == sexdistOID)
		sexdistIndex = a_index
		sexdist = sexdist1[sexdistIndex]
		SetMenuOptionValue(sexdistOID, sexdist1[sexdistIndex])
		;ForcePageReset()
	elseif (a_option == NPCSexCOID)
		SexIndex = a_index
		NPCsexC = sex[SexIndex]
		SetMenuOptionValue(NPCsexCOID, sex[SexIndex])
		if debugActor != none
			RDS.NPC_sexuality[pos] = NPCsexC
			ForcePageReset()
		endif
	elseif (a_option == NPCpersCOID)
		persIndex = a_index
		NPCpersC = pers[persIndex]
		SetMenuOptionValue(NPCpersCOID, pers[persIndex])
		if debugActor != none
			RDS.NPC_personality[pos] = NPCpersC
			ForcePageReset()
		endif
	elseif (a_option == NPCtraitCOID)
		traitIndex = a_index
		NPCtraitC = trait1[traitIndex]
		SetMenuOptionValue(NPCtraitCOID, trait1[traitIndex])
		if debugActor != none
			RDS.NPC_trait1[pos] = NPCtraitC
			ForcePageReset()
		endif
	elseif (a_option == behOID)
		behaviorIndex = a_index
		behavior = behaviorTypes[behaviorIndex]
		SetMenuOptionValue(behOID, behaviorTypes[behaviorIndex])
		;ForcePageReset()
	elseif (a_option == outfitFlagOID)
		outfitFlagIndex = a_index
		outfitFlag = outfitFlags[outfitFlagIndex]
		SetMenuOptionValue(outfitFlagOID, outfitFlags[outfitFlagIndex])		
		;ForcePageReset()
	elseif (a_option == NPCrelStatListOID)
		relstatIndex = a_index
		NPCrelStatList = NPCrelStatArray[relstatIndex]
		SetMenuOptionValue(NPCrelStatListOID, NPCrelStatArray[relstatIndex])
		if debugActor != none
			RDS.NPC_relationshipStatus[pos] = NPCrelStatList
			if NPCrelStatList == "partner"
				RDS.NPC_ID[pos].addToFaction(RDS_Partner)
				RDS.NPC_ID[pos].setFactionRank(RDS_Partner, 1)
				RelationshipScript.newPartner(RDS.NPC_ID[pos])
			else
				if RDS.NPC_ID[pos].isInFaction(RDS_Partner)
					RDS.NPC_ID[pos].removeFromFaction(RDS_Partner)
					RelationshipScript.breakupPartner(RDS.NPC_ID[pos])
				endif
			endif
			ForcePageReset()
		endif
	endIf
		checkArmorList()
		;ForcePageReset()
endEvent

event OnOptionHighlight(int option)
	if (option == purgeOID)
		SetInfoText("Clears all saved NPC data. Only needed for a fresh start or if the storage is full. RDS will notify, if that happens.")
	elseif (option == OnOID)
		SetInfoText("Turn RDS off and on. This option will turn off all approaches and the reputation system.")
	elseif (option == sexdistOID)
		SetInfoText("The chance for a NPCs sexual orientation. It is rolled at the first time a RDS dialogue is accepted. All other orientations have the same chance.")
	elseif (option == NPCdialOID)
		SetInfoText("The chance of a NPC to accept a dialogue initiated by the player.")
	elseif (option == traitOID)
		SetInfoText("The chance of a NPC to be given a trait when first set-up. More info in the debug tab.")
	elseif (option ==CooldownOID)
		SetInfoText("The cooldown in hours, after a NPC approach, before a new one can start. The cooldown is reset when the NPC starts to walk-up to the player, before the start of the dialogue.")
	elseif (option == minArsSexOID)
		SetInfoText("The minimum arousal the NPC must have to accept sex offered by the player. Alternativley if the affection towards the player is 80 or higher the NPC will always accept")
	elseif (option == NPCfightOID)
		SetInfoText("The chance of a NPC to start a fight with the player after a sex or gold demand.")
	elseif (option == FleeGoldOID)
		SetInfoText("The chance of a NPC to flee from the player after a gold demand.")
	elseif (option == FleeSexOID)
		SetInfoText("The chance of a NPC to flee from the player after a sex demand")
	elseif (option == NPCagrOID)
		SetInfoText("Probability of an aggressive animation when an NPC is sexist or in a bad mood. (y < 1)")
	elseif (option == PCSexagrOID)
		SetInfoText("The chance an aggressive SexLab animation is used, when the player makes a sex demand.")
	elseif (option == delOID)
		SetInfoText("Number of days without dialogue before a NPC is deleted. This is checked individually per NPC. Set 0 to disables auto-delete. This option is a precaution and can savely be disabled. \n RDS will notify you if the storage array is full (128 slots).")
	elseif (option == apprGenOID)
		SetInfoText("Only NPC of the specified gender will approach the player. Counts for all scenes.")
	elseif (option == dialChanOID)
		SetInfoText("The chance for an approach to be a generic dialogue or scene instead of a partner or FBW approach.")
	elseif (option == eyeWitOID)
		SetInfoText("The amount by which the players reputation is reduced for every NPC having a line of sight to the player while having sex.")
	elseif (option == earWitOID)
		SetInfoText("The amount by which the players reputation is reduced for every NPC being very close but without line of sight while the player is having sex.")
	elseIf (option == loverRepOID)
		SetInfoText("The amount by which the players reputation is reduced for every lover, that is not the partner. A lover is anybody the player had sex with at least once.")
	elseIf (option == vicRepOID)
		SetInfoText("Being raped reduces the reputation like normal sex.")
	elseIf (option == vicCheatOID)
		SetInfoText("Being raped counts as cheating on a partner.")
	elseIf (option == houLovOID)
		SetInfoText("When toggled, Housecarls don't add a reputation penalty for multiple lovers.")
    elseIf (option == houWitOID)
		SetInfoText("When toggled: Housecarls don't witness sex acts of the player.")
    elseIf (option == comLovOID)
		SetInfoText("When toggled, your current Companions don't add a reputation penalty for multiple lovers.")
    elseIf (option == comWitOID)
		SetInfoText("When toggled, your current Compantions don't witness sex acts of the player.")
	elseIf (option == behOID)
		SetInfoText("Set your characters behavior. This reflects your overall personality. You still can diviate from it in the dialogue.")
	elseIf (option == outfitFlagOID)
		SetInfoText("Here you can add a flag to your current chest-slot armor/ clothes to let it count as more or less revealing. Flaged outfits will affecting NPC arousal diffrently.")
	elseIf (option == sexualityCommentsOID)
		SetInfoText("At the beginning of the dialogue a comment will indicate if a NPC is attracted to the players gender (homo, hetero , bi).")
	elseIf (option == moodCommentsOID)
		SetInfoText("Every other turn during a dialogue a comment will tell the NPCs mood. This can help to better control the conversation.")
	elseIf (option == cheatingCommentsOID)
		SetInfoText("When cheating on a RDS partner, you formed a reationship with through dialogue, a comment will appear.")
	elseIf (option == witnessedCommentsOID)
		SetInfoText("When the player is seen or heard having sex a comment will tell by whom.")
	elseIf (option == reputationStatusCommentsOID)
		SetInfoText("A comment will tell the new reputation value everytime it changes.")
	elseIf (option == affectionCommentsOID)
		SetInfoText("After ending a dialogue a comment will indicate the new relationship-rank of the NPC towards the player.")
	elseIf (option == sexAffectionOID)
		SetInfoText("The amount by which the affection of a NPC is increased every time when having sex.")
	elseIf (option == approachSexualityOID)
		SetInfoText("Only NPC with the chosen sexuality will be valid to approach the player.")
	elseIf (option == nudeWitnessOID)
		SetInfoText("The amount by which the players reputation is reduced for every NPC that has a line of sight to the player, while being nakes or wearing an outfit flagged es naked.")
	elseIf (option == traitWeightPervertedOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightAbusiveOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightCruelOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightColdOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightCunningOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightCharmingOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightRomanticOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightLowSelfEsteemOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == traitWeightPrudeOID)
		SetInfoText("Adjust this weight to make a trait more or less likely. 0 means the trait is disabled. The higher the weight the more likely a trait is. All traits with the same weight have the same propability to appear. \n Example: If all 9 trait have a weight of 1, all traits appear with a 1/9 propability. If one trait had a weight of 2, it'd have a 2/10 chance and all others a 1/10 chance. \n With one trait at weight 10 and all others at 1, it'd have a chance of 10/18 and the others a chance of 1/18 each.")
	elseIf (option == unmatchingSexualityOID)
		SetInfoText("When toggled, hook-up options are blocked for NPC if their sexual interest does not match the players gender. They will also always decline sex invitations. This option does not affect sex demands.")
	elseIf (option == positiveAffectionLimitOID)
		SetInfoText("NPC will need an affection of this or higher to be able to use trust related options, like friendship, serious relationships or friendship+. This affects all Y = 5 options. This will prevent stranger from being too intimate.")
	elseIf (option == negativeAffectionLimitOID)
		SetInfoText("NPC will need an affection of this or lower to be able to use the most aggressive options like rape, fighting or insult. This affects all Y = -5 options. This will prevent friends from becoming violent.")
	elseIf (option == flirtLimitOID)
		SetInfoText("Minimum needed player arousal to be able to use flirt options.")
	elseIf (option == nonFlirtLimitOID)
		SetInfoText("Maximum allowed player arousal to still be able to use non-flirt options.")
	elseIf (option == sexDemandLimitOID)
		SetInfoText("Minimum needed player arousal to use the demand sex option.")
	elseIf (option == sexInviteLimitOID)
		SetInfoText("Minimum needed player arousal to use the sex invite option.")
	elseIf (option == playerSubmissionOID)
		SetInfoText("This sets when the players arousal will be increased. NORMAL: Only on nice flirting (Y > -1). SUBMISSIVE: Only on mean flirting (Y < 0). SWITCHER: Always equally.")
	elseIf (option == NPC_dialogueCooldownOID)
		SetInfoText("How long a specific NPC is unavailable for dialogue, after talking to him.")
	elseIf (option == rep0OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == empty2OID)
		SetInfoText("Perverted NPC get a extra -2 X every turn. This is overpowered by very low arousal.")
	elseIf (option == empty3OID)
		SetInfoText("Cruel NPC get -1 Y and can't get higher than X = 2. That makes then meaner and never insecure or frindly.")
	elseIf (option == empty4OID)
		SetInfoText("Prude NPC get +2 X every turn. This can be overpowered by high arousal.")
	elseIf (option == empty5OID)
		SetInfoText("low self-esteem NPC get +1 X and -1 Y every turn, making them rather resentful.")
	elseIf (option == empty6OID)
		SetInfoText("Cold NPC can't get a Y value beyond 3 or -3. That blocks all loving or hateful options.")
	elseIf (option == empty7OID)
		SetInfoText("Cunning NPC get -2 X and +2 Y. This maked them very charming and flirty. But this trait is removed once they had sex with the player. They just want to hook-up and then get uninteressted.") 
	elseIf (option == empty8OID)
		SetInfoText("Romantic NPC get a pull towards love and relationships. They tend to form relationships earlier.")
	elseIf (option == empty9OID)
		SetInfoText("Abusive NPC get a pull towards verbally and physically abusive topics.")
	elseIf (option == empty10OID)
		SetInfoText("Charming NPC get +1 X making them a bit nicer.")
	elseIf (option == rep1OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep2OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep3OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep4OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep5OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep6OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep7OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep8OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == rep9OID)
		SetInfoText("The Reputation is counted in each Hold seperately. Once decreased, it never rises again by itself. For each witness or lover it is stoared how many rep point it caused to reduce. So killing off witnesses and lover is the only way to resore your reputaion by now. \n 100 = innocent, 99-75 = faithful, 74-50 = playful, 49-25 = adventurous, 24-0 = unfaithful, 0 = whore \n Rep: 50 is the line of what is socially accepted.")
	elseIf (option == approachToggleOID)	
		SetInfoText("Use this option to turn off NPC approaches, while still keeping the reputaion scans active. Partner refers to vanilla spouses and relationships formed within RDS.")
	elseIf (option == filteredPurgeOID)
		SetInfoText("When toggled, only NPCs who have the relationship status of STRANGER, and are no witnesses, are deleted if the time limit is reached. Use this to prevent partners and lovers from being deleted, while getting rid of randoms")
	elseIf (option == dirtOID)
		SetInfoText("Turns the respawning dirt in the vanilla player home on and off.")
	elseIf (option == litterOID)
		SetInfoText("Turns the dropping of empfty bottles by partners on and off.")
	elseIf (option == rapeNudeWitnessOID)
		SetInfoText("Disables the witness system when being raped.")
	elseIf (option == foreplayOID)
		SetInfoText("Foreplay animations don't count as being witnessed having sex.")
	elseIf (option == fzCooldownOID)
		SetInfoText("The number of days you need to avoid talking to a NPC that has you in the friendzone before it is removed. Set to 0 to have it instantly removed. \n The Friendzone is also removed when affection falles to -10 or lower after a dialogue - getting into a big fight and rebuilding the relationship works too. ")
	endif
endevent

function checkArmorList()
	Utility.Wait(0.1)				; holds the function while in menu mode
	if outfitFlag == "normal"
		armor wornArmor = game.GetPlayer().GetWornForm(0x00000004) as Armor
		int Z = bodyArmorStorage.find(wornArmor)
		bodyArmorStorage[Z] = none
	else
		saveOutfitFlag()		
	endif
endFunction

function saveOutfitFlag()
	armor wornArmor = game.GetPlayer().GetWornForm(0x00000004) as Armor
	int Z = bodyArmorStorage.find(wornArmor)
	if Z < 0									;armor not yet stored
		Z = bodyArmorStorage.find(none)
	endif
	if Z < 0									;armor array full
		Debug.Messagebox("Outfit storage is full! Your new setting couldn't be saved. Please delete outfits by setting them to normal to be able to save new ones.")
	else
		bodyArmorStorage[Z] = wornArmor
		bodyArmorFlagStorage[Z] = outfitFlag	
	endif
endfunction


Armor[] Property bodyArmorStorage  Auto  

String[] Property bodyArmorFlagStorage  Auto  
