Scriptname RDS_playerArmorUnequipScript extends ReferenceAlias  

actor property PlayerRef auto
keyword property ArmorCuirass auto
keyword property ClothingBody auto
RDS_MCM property MCM auto
quest property RDS_playerApproach auto
rds_playerApproachScript property main auto
bool property nudeScanActive = false auto hidden

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	if !nudeScanActive																			
		if nudeCheck()
			main.nudeWitnessArray = new Actor[128]
			main.nudeWitnessCount = 0
			nudeScanActive = true
			main.handleNakedLOS()
			RDS_playerApproach.RegisterForUpdate(5)
		else
			nudeScanActive = false
			RDS_playerApproach.UnregisterForUpdate()
		endif
	endif
EndEvent

;Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
;	if nudeScanActive
;		if nudeCheck()
;			main.nudeWitnessArray = new Actor[128]
;			main.nudeWitnessCount = 0
;			nudeScanActive = true
;			main.handleNakedLOS()
;			RDS_playerApproach.RegisterForUpdate(5)
;		else
;			nudeScanActive = false
;			RDS_playerApproach.UnregisterForUpdate()
;		endif
;	endif
;EndEvent		

bool Function nudeCheck()
	if MCM.nudeWitness > 0.0 && MCM.on
		
		bool playerIsClothed = false

		If playerRef.wornHasKeyword(ArmorCuirass) || playerRef.wornHasKeyword(ClothingBody)
			playerIsClothed = true
		endif

		if !playerIsClothed	
			return true
		else
			if customNakedArmor()
				return true
			else
				return false
			endif
		endif
	else
		return false
	endIf
endfunction

bool function customNakedArmor()
	armor myArmor = playerRef.getWornForm(0x00000004) as Armor
	int index = MCM.bodyArmorStorage.find(myArmor)
	if index > -1 && MCM.bodyArmorFlagStorage[index] == "naked"	
		return true
	else 
		return false
	endif
endfunction